package activity;

import basic.FiringManagerThread;
import basic.StateManagerHashSetAdapter;
import basic.StateSetArrayAdapter;
import gui.Configuration;
import interfaces.AbstractController;
import interfaces.IActivityMonitor;
import interfaces.IFiringManager;
import interfaces.IModelFactory;
import interfaces.IStateManager;
import interfaces.IStateSet;

public class ActivitySupervisorController extends AbstractController {

	
	protected ActivitySupervisorController(IModelFactory mf) {
		super(mf);
		initialize();
	}
	
	protected IActivityMonitor createActivityMonitor() {
		return new ActivityListenerMultiProxy (Configuration.getConf().getNbNodes());
	}
	
	protected IFiringManager createFiringManager() {
		return new FiringManagerThread(nss_,sm_,mf_);
	}

	protected IStateManager createStateManager() {
		return new StateManagerHashSetAdapter (nss_);
	}

	protected IStateSet createStateSet() {
		return new StateSetArrayAdapter ();
	}

	public void close() {
		return;
	}

}
