package activity;

import gui.Configuration;
import interfaces.AbstractController;
import interfaces.IFiringManager;
import interfaces.IModelFactory;
import interfaces.IStateManager;
import interfaces.IStateSet;

import java.io.IOException;

import basic.StateSetArrayAdapter;
import basic.FiringManagerThread;
import basic.StateManagerHashSetAdapter;


public class ObservableActivityController extends AbstractController {

	private ActivityListenerService als_;
	
	protected ObservableActivityController(IModelFactory mf) throws IOException {
		super(mf);
		initialize();
		// nss and activity service
		als_ = new ActivityListenerService (nss_);
		als_.startServer(Configuration.getConf().getAMPort());
	}
	
	
	
	protected IStateManager createStateManager() {
		return new StateManagerHashSetAdapter  (nss_);
	}

	protected IFiringManager createFiringManager() {
		return new FiringManagerThread(nss_,sm_,mf_);
	}

	protected IStateSet createStateSet() {
		return new StateSetArrayAdapter();
	}

	public void close() {
		try {
			als_.stopServer();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return;
	}
	
	
}
