package basic;

import interfaces.AbstractController;
import interfaces.IFiringManager;
import interfaces.IModelFactory;
import interfaces.IStateManager;
import interfaces.IStateSet;

public class BasicController extends AbstractController {

	public BasicController(IModelFactory mf) {
		super(mf);
		initialize();
	}

	protected IFiringManager createFiringManager() {
		return new FiringManagerThread(nss_,sm_,mf_);
	}

	protected IStateManager createStateManager() {
		return new StateManagerHashSetAdapter(nss_);
	}

	protected IStateSet createStateSet() {
		return new StateSetArrayAdapter();
	}
	
	public void close() {
		return;
	}
}
