package basic;

import interfaces.IState;
import interfaces.IStateManager;
import interfaces.IStateSet;
import interfaces.StatAggregator;

import java.util.HashSet;
import java.util.Iterator;


public class StateManagerHashSetAdapter implements IStateManager {
	HashSet<IState> hash_;
	private IStateSet nss_;
	private int seen;
	
	public StateManagerHashSetAdapter (IStateSet nss) {
		hash_= new HashSet<IState> ();
		nss_ = nss;
		seen = 0;
	}
	
	public synchronized void processState(IState s) {
		++seen;
		if ( hash_.add(s))
			nss_.pushState(s);	
	}

	public synchronized Iterator<IState> elements() {
		return hash_.iterator();
	}

	public void getStats(StatAggregator stats) {
		stats.agregate("\nHash state manager : seen=" + seen + " stored=" + hash_.size());
	}

	public void close() {
		hash_.clear();
	}
}
