package cami;


import java.util.NoSuchElementException;
import java.util.StringTokenizer;
import java.util.Vector;

public class FKCommand {
	CAMI code = null ;
	Vector<String> args = new Vector<String>();


	public FKCommand (String msg) {
		args = parseArgs(msg);
	}

	public FKCommand (CAMI code) {
		this.code = code;
	}

	public FKCommand(CAMI fs, int i) {
		this.code = fs;
		addArg(i);
	}

	public FKCommand(CAMI sc, String userName, String password) {
		this.code = sc;
		addArg(userName);
		addArg(password);
	}

	public FKCommand(CAMI oc, String name, String version, String userName,int o) {
		this.code = oc;
		addArg(name);
		addArg(version);
		addArg(userName);
		addArg(o);
	}

	public FKCommand(CAMI os, String sessionName, int date,
			String sessionFormalism) {
		this.code = os;
		addArg(sessionName);
		addArg(date);
		addArg(sessionFormalism);
	}

	public FKCommand(CAMI ci, String sessionName, int i) {
		code = ci;
		addArg(sessionName);
		addArg(i);
	}

	public FKCommand(CAMI pq, String root, String name, int i) {
		code = pq;
		addArg(root);
		addArg(name);
		addArg(i);
	}

	public FKCommand(CAMI ca, String arctype, int id, int src,int dest) {
		code = ca;
		addArg(arctype);
		addArg(id);
		addArg(src);
		addArg(dest);
	}

	private void addArg(String s) {
		args.add(CamiParser.stringToCAMI(s));
	}

	private void addArg(int i) {
		args.add(Integer.toString(i));
	}

	public String toString () {
		if (code==null)
			return "";
		StringBuffer sb = new StringBuffer(255);
		sb.append(code);
		if (args.isEmpty())
			sb.append("()");
		else {
			sb.append("(");
			for (String arg :args) {
				if (arg != null)
					sb.append(arg);
				sb.append(',');
			}
			sb.setCharAt(sb.length()-1, ')');
		}
		return sb.toString();
	}

	public static byte[] toPacket (String s) {
		byte[] msg = s.getBytes();
		int len = msg.length;
		byte[] toSend = new byte[len + 4];

		assert(len < 256);
		// Entete
		toSend[0] = 0;
		toSend[1] = 0;
		toSend[2] = 0;
		toSend[3] = (byte) (len);
		System.arraycopy(msg, 0, toSend, 4, len);
		return toSend;
	}
	
	public byte[] toPacket () {
		return toPacket(toString());
	}



	/**
	 * Recupere sous forme de vecteur la commande recue et l'ensemble des argument de la commande
	 * @param commande commande recue
	 * @return Vecteur des arguements recus
	 */
	public Vector<String> parseArgs(String commande) {
		String cmdString = "";

		StringTokenizer st = new StringTokenizer(commande);
		CamiParser parser = null;

		try {
			// Construit le parser sur la chaine d'arguments
			parser = new CamiParser(commande);
			// Code de la commande
			cmdString = st.nextToken("(");
		} catch (NoSuchElementException e) {
			return null;
		} catch (StringIndexOutOfBoundsException e) {
			return null;
		}

		// Premier element du vecteur : le sigle de la commande
		code = CAMI.find(cmdString);
		if (code == null) {
			throw new NullPointerException("Protocol layer error, unrecognized cami command "+cmdString 
					+" while parsing " + commande);
		}
		return parser.parse();

	}

	public CAMI getCode() {
		return code;
	}

	public String get (int i) throws ArrayIndexOutOfBoundsException {
		return args.get(i);
	}
}

