package cluster;

import java.io.IOException;

import multi.FiringManagerMulti;




import gui.Configuration;
import interfaces.IFiringManager;

public class FiringManagerMultiProxy extends FiringManagerMulti implements
		IFiringManager {

	public FiringManagerMultiProxy(int nbthreads) {
		super(nbthreads);
	}

	@Override
	protected IFiringManager createFiringManager(int i) {
		FiringManagerProxy fm = new FiringManagerProxy();
		fm.setServer(Configuration.getConf().getHostIP(i),Configuration.getConf().getFMPort(i));
		try {
			fm.connect();
		} catch (IOException e) {
			System.err.println("Fatal FiringManager connection error when connecting to node "+i
					+ " Ip :"+Configuration.getConf().getHostIP(i)
					+ ":" + Configuration.getConf().getSMPort());
			e.printStackTrace();
		}
		return fm;
	}

}
