package cluster;

import java.io.IOException;

import interfaces.IFiringManager;
import interfaces.StatAggregator;
import protocol.Message;
import protocol.MsgType;
import protocol.TCPServeurMessage;

public class FiringManagerService extends TCPServeurMessage {

	
	private IFiringManager concreteFM_;

	public FiringManagerService(IFiringManager fm) {
		concreteFM_ = fm;
	}

	public void gereClient() {
		try {
			while (true) {
				Message m = getMessage();
				switch (m.head) {
				case PROCESS_INITIAL_REQ : {
					concreteFM_.processInitialState();
					break;
				}
				case START_GEN_REQ : {
					concreteFM_.startGeneration();
					break;
				}
				case STATS_REQ :  {
					StatAggregator s = new StatAggregator();
					concreteFM_.getStats(s);
					sendMessage(new Message(MsgType.STATS_RESP,s));
					break;
				}
				}
			}
		} catch (IOException e){
			return;
		}

	}

}
