package cluster;

import java.io.IOException;

import dhash.StateManagerMulti;
import dhash.StateManagerProxy;


import gui.Configuration;
import interfaces.IStateManager;
import interfaces.StatAggregator;

public class StateManagerMultiProxy extends StateManagerMulti implements
		IStateManager {

	public StateManagerMultiProxy(int nbnodes) {
		super(nbnodes);
	}

	
	protected IStateManager createStateManager(int index) {
		StateManagerProxy smp = new StateManagerProxy ();
		smp.setServer(Configuration.getConf().getHostIP(index),Configuration.getConf().getSMPort(index));
		try {
			smp.connect();
		} catch (IOException e) {
			System.err.println("Fatal StateManager connection error when connecting to node "+index
								+ " Ip :"+Configuration.getConf().getHostIP(index)
								+ ":" + Configuration.getConf().getSMPort());
			e.printStackTrace();
			return null;
		}
		return smp;
	}
	
	@Override
	public void getStats(StatAggregator stats) {
		super.getStats(stats);
		for (IStateManager s:pool) {
			if (s instanceof StateManagerProxy) {
				StateManagerProxy sm = (StateManagerProxy) s;
				sm.getDistantStats(stats);
			}
		}
	}

}
