package dhash;

import java.io.IOException;

import basic.StateSetArrayAdapter;
import basic.FiringManagerThread;
import gui.Configuration;
import interfaces.AbstractController;
import interfaces.IFiringManager;
import interfaces.IModelFactory;
import interfaces.IStateManager;
import interfaces.IStateSet;

public class DHashController extends AbstractController {

	private StateManagerService sms_;
	private int nbnodes;

	public DHashController(IModelFactory mf, int nbnodes) {
		super(mf);
		this.nbnodes = nbnodes;
		initialize();
		// sm service		
		sms_ = new StateManagerService (sm_);
		try {
			sms_.startServer(Configuration.getConf().getSMPort());
		} catch (IOException e) {
			System.err.println("Could not start sm server on port"+ Configuration.getConf().getSMPort());
			e.printStackTrace();
		}
	}

	protected IStateManager createStateManager() {
		return new DistributedHashTable (nbnodes,nss_);
	}

	protected IFiringManager createFiringManager() {	
		return new FiringManagerThread(nss_,sm_,mf_);
	}

	protected IStateSet createStateSet() {
		return new StateSetArrayAdapter();
	}
	
	public void close() {
		try {
			sms_.stopServer();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return;
	}
}
