package dhash;

import gui.Configuration;
import gui.NodeConfiguration;
import interfaces.IStateManager;
import interfaces.IStateSet;

import java.io.IOException;


import basic.StateManagerHashSetAdapter;


public class DistributedHashTable extends StateManagerMulti {

	

	private IStateSet localnss_;
	
	public DistributedHashTable(int nbnodes,IStateSet nss_) {
		super(nbnodes);
		localnss_ = nss_;
	}

	protected IStateManager createStateManager(int index) {
		if (index == Configuration.getConf().getLocalId())
			return new StateManagerHashSetAdapter(localnss_);	
		else {
			StateManagerProxy smp = new StateManagerProxy ();
			NodeConfiguration serv= Configuration.getConf().getNodeConf(index);
			smp.setServer(serv.getIP(),serv.getSmPort());
			try {
				smp.connect();
			} catch (IOException e) {
				System.err.println("Fatal StateManager connection error when connecting to node "+index
									+ " Ip :"+Configuration.getConf().getHostIP(index)
									+ ":" + Configuration.getConf().getSMPort());
				e.printStackTrace();
				System.exit(1);
				return null;
			}
			return smp;
		}
	}

}
