package dhash;

import interfaces.IState;
import interfaces.IStateManager;
import interfaces.StatAggregator;

import java.util.Iterator;
import java.util.Vector;


public abstract class StateManagerMulti implements IStateManager {

	protected Vector<IStateManager> pool;
	protected int nbnodes;
	private int seen=0;

	abstract protected IStateManager createStateManager (int index) ;



	synchronized private IStateManager getSM(int i) {
		IStateManager sm = pool.get(i);
		if (sm == null) {
			pool.set(i,createStateManager(i));
			sm = pool.get(i);
		}
		return sm;
	}

	public StateManagerMulti (int nbnodes) {
		this.nbnodes =nbnodes;
		pool = new Vector<IStateManager> (nbnodes);
		pool.setSize(nbnodes);
	}

	public Iterator<IState> elements() {
		// TODO Auto-generated method stub
		return null;
	}

	public void processState(IState s) {
		// localisation
		int n = s.hashCode() % nbnodes;
		++seen;
		getSM(n).processState(s);
	}

	public void getStats(StatAggregator stats) {
		stats.agregate("\n Multi State manager, nbNodes=" + nbnodes + " seen="+seen +" components : ");
		for (int i=0 ; i < nbnodes; i++) {
			getSM(i).getStats(stats);						
		}
	}

	public void close() {
		for (IStateManager sm : pool) {
			if (sm != null) sm.close();
			sm=null;			
		}
	}	

}
