package dhash;

import interfaces.IState;
import interfaces.IStateManager;
import interfaces.StatAggregator;

import java.io.IOException;
import java.util.Iterator;

import protocol.Message;
import protocol.MsgType;
import protocol.TCPClientMessage;

public class StateManagerProxy extends TCPClientMessage implements
IStateManager {

	private int nbSent = 0;

	public Iterator<IState> elements() {
		// TODO Auto-generated method stub
		return null;
	}

	public void processState(IState s) {
		try {
			sendMessage(new Message(MsgType.PROCESS_STATE,s));
			++nbSent;
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void getStats(StatAggregator stats) {
		stats.agregate("\nSM proxy to host="+ servAdr.getHostName() + ":" + servPort + " sent="+nbSent);

	}
	public void getDistantStats(StatAggregator stats) {
		stats.agregate("\nSM proxy to host="+ servAdr.getHostName() + ":" + servPort + " sent="+nbSent);
		try {
			sendMessage(new Message(MsgType.STATS_REQ));
			Message m = getMessage();
			assert(m.head == MsgType.STATS_RESP);
			stats.agregate(m.data.get(0));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void close() {
		disconnect();
	}

}
