package ipn.composite;

import ipn.IPNInstance;
import ipn.IPNLabeledState;
import ipn.IPNType;

public class LabeledCompositeState extends CompositeState implements IPNLabeledState {

	private String name;

	public LabeledCompositeState(CompositeNet net,String name) {
		super(net);
		this.name = name;
	}
	
	public String getName() {
		return name;
	}

	public String toString(IPNType n) {
		CompositeNet net = (CompositeNet) n;
		StringBuffer sb = new StringBuffer();
		sb.append( "\tstate "+name+" {\n");
		sb.append( super.toString(n));
		sb.append("\t}\n");
		return sb.toString();
	}

	protected String getSubstateString(IPNInstance inst) {
		return ((IPNLabeledState)getSubstate(inst)).getName();
	}

	public boolean equals(Object obj) {
		if (obj == null && name.equals("default"))
			return true;
		return super.equals(obj);
	}
}
