package libpetri.dmcPetri;

import interfaces.IModelEngine;
import interfaces.IState;
import interfaces.StatAggregator;

import java.util.Enumeration;

import libpetri.structure.Net;
import libpetri.structure.state.State;

public class PetriEngine implements IModelEngine {

	Net net;
	
	public PetriEngine(Net net) {
		this.net = net;
	}

	public IState getInitial() {
		return (IState) net.getInitialState();
	}


	public void getStats(StatAggregator stats) {
		stats.agregate ("LibPetri here !");
		
	}


	public Enumeration<IState> getSuccessors(IState cur) {
		return new StateItfAdapter (net.getSuccessors((State) cur));
	}

}
