package libpetri.namespaces;

public class NamedElement {
	protected String name;
	private Namespace namespace;
	
	public NamedElement(String name) {
		this.name = name ;
		namespace = null;
	}
	
	/* protected to forbid anarchic access to namespace. 
	 * Correct way of defining a namespace is through Namespace.add operation.
	 */
	protected void setNamespace (Namespace n) throws NamingException {
		if (namespace != n) {
			if (namespace != null) {
				// changing namespace
				namespace.remove(this);
			}
			namespace = n ;
			namespace.add(this);
		}
//		if (namespace != null) {
//			throw new NameExistsException (
//					"Object "+getFullyQualifiedName() + " already has a name ; " 
//					+ "cannot set namespace to " );
//		}
	}
	
	public String getFullyQualifiedName () {
		if (namespace != null)
			return namespace.getFullyQualifiedName() + "." + name;
		else 
			return name;
	}
	public String getFullyQualified_Name () {
		String s = getFullyQualifiedName();
		String[] vect = s.split("\\.");
		StringBuffer sb= new StringBuffer();
		sb.append(vect[0]);
		for (int i= 1 ; i < vect.length ; i++) {
			sb.append("_"+vect[i]);
		}
		return sb.toString();
	}
	
	public void setName (String name) throws NamingException {
		if (namespace != null ){
			namespace.remove(this);
			this.name = name;
			namespace.add(this);
//			throw new NamingException ("Cannot change object name after setting owner namespace.");
		} else {
			this.name = name;
		}
	}

	public String getName() {
		return name;
	}
	
	public Namespace getNamespace() {
		return namespace;
	}
	
	public String toString() {
		return getName();
	}
}
