package libpetri.namespaces;

import java.util.Enumeration;
import java.util.Hashtable;

public class Namespace extends NamedElement {

	Hashtable <String,NamedElement> ownedMembers = new Hashtable<String, NamedElement>();
	
	public Namespace(String name) {
		super(name);
	}
	
	
	public static final Namespace Root=new Namespace("/");

	
	public boolean add(NamedElement element) 
		throws NamingException {
		NamedElement old = ownedMembers.get(element.name);
		if (old != null) {
			if (old.equals(element)) 
				return false;

			throw new NamingException ("Cannot create object with name " + element.name 
					+ " because the name " + old.getFullyQualifiedName() +
					" refers to " +  old);
		} else {
			ownedMembers.put(element.name, element);
			element.setNamespace(this);
			return true;
		}
	}


	public boolean remove(NamedElement element) {
		NamedElement ne = ownedMembers.remove(element.name);
		if (ne == null || ! ne.equals(element))
			return false;
		else
			return true;
	}
	
	public NamedElement find (String name) {
		String[] s = name.split("\\.",2);
		if (s.length > 1) {
			try {
				Namespace n = (Namespace) find(s[0]);
				return n.find(s[1]);
			} catch (ClassCastException e) {
				return null;
			}
		}
		return ownedMembers.get(name);
	}
	
	public Enumeration<NamedElement> elements () {
		return ownedMembers.elements();
	}
	
	public String toString() {
		return super.toString() + ownedMembers.keySet();
	}
}
