package libpetri.structure.arcs;

import java.util.Collection;
import java.util.Vector;

import libpetri.nets.ISymmetricNet;
import libpetri.structure.state.State;

public class ArcSet extends Vector<Arc> implements Collection<Arc> {

	public boolean isEnabled(State s,int []bindings) {
		for (Arc a : this) {
			if (! a.isEnabled(s,bindings))
				return false;
		}
		return true;
	}

	public void fire(State s2,int [] bindings) {
		for (Arc a : this) {
			a.fire(s2,bindings);
		}
	}

	public void flatten(ISymmetricNet receiver, String alias) {
		for (Arc a : this) {
			a.flatten(receiver,alias);
		}
	}
}
