package libpetri.structure.arcs;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import libpetri.structure.Domain;
import libpetri.structure.Place;
import libpetri.structure.Transition;
import libpetri.structure.TypeDef;
import libpetri.structure.Visibility;

public class ParseFunction {


	
/**
 * @label produces
 */

/*#structure.arcs.Function Dependency20*/

public static Function parse (Place p, Transition t, String fun) {
		Function f = new Function(p.getDom().getDims());


		Pattern pat = Pattern.compile("^\\s*(\\d+)\\s*('\\s*<\\s*(.*?)\\s*>\\s*){0,1}$" );

		String[] toks = fun.split("\\+");
		for (String tok : toks) {
			Matcher matcher = pat.matcher(tok);
//			boolean found = false;
			while (matcher.find()) {
				int [] coord = new int [p.getDom().getDims().length];
				int card = Integer.parseInt(matcher.group(1));
//				System.out.println("I found the text \""+matcher.group()+"\" starting at " +
//						"index "+matcher.start()+" and ending at index "+ matcher.end());
				boolean doAdd = true;
				if (matcher.group(3) != null) {
					String[] toktab = matcher.group(3).split("\\s*,\\s*");
					int i=0;
					for (String elt : toktab) {
						if (elt.equals("")) break;
//						System.err.println("elt : \"" + elt + "\"");
						coord[i] = p.getDom().get(i).getIndex(elt);
						if (coord[i] <0) {
							coord[i] = t.getVarIndex(elt);
							if (coord[i] >0) {
								System.err.println("parse error, unknown element \""+elt+"\" in token \"<" + matcher.group(3) + ">\" supposed to be of domain "+p.getDom());
								doAdd = false;
								break;
							}	
						}
						i++;
					}
					if (!doAdd)
						break;
					if ( i < p.getDom().size())  {
						System.err.println("parse error, not enough elements in token \"<" + tok + ">\" supposed to be of domain "+p.getDom());
						doAdd = false;
						break;
					}
				}
				if (doAdd)
					f.add(coord, card);
//				for (int i = 1; i <= matcher.groupCount(); i++) 
//					System.out.println("group " +i + " :"+matcher.group(i));
//				found = true;
			}

//			if(!found){
//				System.out.println("No match found.");
//			}
		}

		return f;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TypeDef t = new TypeDef("test","aa,bb,cc,dd");
		Domain d = new Domain("tesd");
		d.add(t);
		d.add(t);
		d.add(t);
		Place p = new Place("toto",d);
		Transition tr = new Transition("titi",Visibility.PRIVATE);
		Function ps = ParseFunction.parse(p,tr,"3 '< aa,  bb,cc>+ 2 '<>+ 1'<aa,bb,aa>"); 
		System.out.println(ps);		
	}

}
