package libpetri.test;


import libpetri.structure.Net;
import libpetri.structure.Visibility;
import libpetri.structure.arcs.ArcType;

public class Client extends Net{
	
	public Client(String name) {
		super(name);
		
		createPlace("idle");
		createPlace("wait");
		createPlace("readAck");		
		
		createTransition("sendReq",Visibility.PUBLIC);
		createArc("idle", "sendReq", ArcType.INPUT);
		createArc("wait", "sendReq", ArcType.OUTPUT);
		
		createTransition("getAck",Visibility.PUBLIC);
		createArc("wait", "getAck", ArcType.INPUT);
		createArc("readAck", "getAck", ArcType.OUTPUT);
		
		createTransition("doOperation",Visibility.PRIVATE);
		createArc("readAck", "doOperation", ArcType.INPUT);
		createArc("idle", "doOperation", ArcType.OUTPUT);

		setPlaceState("idle","1");
	}

	public static void main(String[] args) {
		Net n = new Client("c1");
		
		System.out.println(n);
		
		n.generateStateSpace();
	}
}
