package libpetri.test.philo;

import java.io.FileNotFoundException;
import java.util.Calendar;

import libpetri.dot.DOTnet;
import libpetri.structure.Net;

public class FourPhiloTable extends PhiloTable {

	public FourPhiloTable(String name) {
		super(name);
	}


	public Net createPFcomponent() {
		return new FourPhil("pf");
	}

	
	public static void main(String[] args) {
		Net n  = new FourPhiloTable("tableForFour");

		System.out.println(n);
		Net unfold = new Net("unfolded");
		n.flatten(unfold);
		System.out.println(unfold);
		{
			Calendar c = Calendar.getInstance();
			unfold.generateStateSpace();
			Calendar c2 = Calendar.getInstance();
			System.out.println(" elapsed : "+ (c2.getTimeInMillis()-c.getTimeInMillis())+"ms");
		}
		{
			Calendar c = Calendar.getInstance();
			n.generateStateSpace();
			Calendar c2 = Calendar.getInstance();
			System.out.println(" elapsed : "+ (c2.getTimeInMillis()-c.getTimeInMillis())+"ms");

		}
		try {
			DOTnet a = new DOTnet("FourPhil");
			unfold.convert(a);
			a.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}
