package libpetri.test.philo;

import libpetri.structure.Net;
import libpetri.structure.Visibility;

public abstract class PhilCompose extends Net {

	public abstract Net createP1component ();
	public abstract Net createP2component ();
	
	
	public PhilCompose(String name) {
		super(name);

		createComponent(createP1component());
		createComponent(createP2component());
		
		createSynchronization("getInternal", Visibility.PRIVATE);
		addSynchronize("getInternal", "p2.getLeft");
		addSynchronize("getInternal", "p1.get");
		
		createSynchronization("releaseInternal", Visibility.PRIVATE);
		addSynchronize("releaseInternal", "p2.finishEat");
		addSynchronize("releaseInternal", "p1.put");
		
		// export left fork 
		createSynchronization("getLeft", Visibility.PUBLIC);
		addSynchronize("getLeft", "p1.getLeft");

		createSynchronization("finishEat",Visibility.PUBLIC);
		addSynchronize("finishEat", "p1.finishEat");
		//addSynchronize("finishEat", "p2.put");
		
		// export fork public transitions
		createSynchronization("get", Visibility.PUBLIC);
		addSynchronize("get", "p2.get");
		
		createSynchronization("put", Visibility.PUBLIC);
		addSynchronize("put", "p2.put");
		
	
	}

	
	
}
