package micropilot;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;


public class CamiFileModel implements ICamiModel {
	
	private String modelPath;
	private String name;
	
	public String getName() {
		return new File(name).getName();
	}

	public CamiFileModel(String modelPath) {
		this.modelPath = modelPath;
		name = modelPath;
	}


	class FileLineIterator implements Iterator<String> {

		BufferedReader br ;
		private String strLine;
		
		public FileLineIterator(BufferedReader br) {
			this.br = br;
			strLine = null;
		}
		
		public boolean hasNext() {
			try {
				strLine = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return false;
			}
			return strLine != null;
		}

		public String next() {
			return strLine;
		}

		public void remove() {
			System.err.println("Unimplemented remove in FileLineIterator");
		}
		
	}
	
	class FileAsStrings implements Collection<String> {

		private BufferedReader br;

		public FileAsStrings(BufferedReader br) {
			this.br = br;
		}

		public boolean add(String o) {
			return false;
		}

		public boolean addAll(Collection<? extends String> c) {
			return false;
		}

		public void clear() {
		}

		public boolean contains(Object o) {
			return false;
		}

		public boolean containsAll(Collection<?> c) {
			return false;
		}

		public boolean isEmpty() {
			return false;
		}

		public Iterator<String> iterator() {
			return new FileLineIterator(br);
		}

		public boolean remove(Object o) {
			return false;
		}

		public boolean removeAll(Collection<?> c) {
			// TODO Auto-generated method stub
			return false;
		}

		public boolean retainAll(Collection<?> c) {
			// TODO Auto-generated method stub
			return false;
		}

		public int size() {
			// TODO Auto-generated method stub
			return 0;
		}

		public Object[] toArray() {
			// TODO Auto-generated method stub
			return null;
		}

		public <T> T[] toArray(T[] a) {
			// TODO Auto-generated method stub
			return null;
		}
		
	}
	
	public Collection<String> translate() {
		
			// Open the file that is the first 
			// command line parameter
			FileInputStream fstream;
			try {
				fstream = new FileInputStream(modelPath);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return new Vector<String>();
			}
			//FileOutputStream OutputStream = new FileOutputStream("output.txt");
			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			
			return new FileAsStrings (br);
	}

	public long getDate() {
		return new File(modelPath).lastModified();
	}

}
