package simple;

import interfaces.IModelEngine;
import interfaces.IState;
import interfaces.StatAggregator;

import java.util.Enumeration;



public class SimpleModel implements IModelEngine {
	static int tabTR[][];
	static final int Branching = 5;
	static final int NbStates = 500000;
	
	
	public SimpleModel () {
		tabTR = new int[NbStates][Branching];
		for (int i = 0; i< NbStates ; i++) {
			for (int k=0 ; k < Branching ; k++) {
				tabTR[i][k]=(23*i+k)% NbStates;
			}			
		}
	}
	
	public IState getInitial() {
		return new IntegerState (0);
	}

	public Enumeration<IState> getSuccessors(IState cur) {
		return new SimpleSuccIterator ( ((IntegerState)cur).value() );
	}

	public void getStats(StatAggregator stats) {
		stats.agregate("Simple model ;"
				+ "Branching "+Branching + " nb states : " + NbStates );
	}

	
}

class SimpleSuccIterator implements Enumeration<IState> {
	private int ori;
	private int cur;

	SimpleSuccIterator (int i) {
		ori = i;
		cur = 0;
	}

	public boolean hasMoreElements() {
		return cur < SimpleModel.Branching ;
	}

	public IState nextElement() {
		return new IntegerState(SimpleModel.tabTR[ori][cur++]);
	}
			
}