package transform.gui;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import micropilot.Level;

public class LevelRenderer extends DefaultTableCellRenderer
                           implements TableCellRenderer {

	public LevelRenderer() {
        setOpaque(true); //MUST do this for background to show up.
    }

    public Component getTableCellRendererComponent(
                            JTable table, Object value,
                            boolean isSelected, boolean hasFocus,
                            int row, int column) {
       	if (value instanceof Level) {
			Level lev = (Level) value;
			switch (lev) {
			case STATISTIC :
				setBackground(Color.green);
				break;
			case WARNING :
				setBackground(Color.yellow);
				break;
			case ERROR :
				setBackground(Color.red);
				break;
			}
			setText(lev.toString());
			return this;
       	} else {
       		return super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
       	}
    }
}
